<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2/25/2019
 * Time: 8:47 AM
 */

/*
Plugin Name: Traveler Billplz
Description: This plugin is used for Traveler Theme
Version: 1.2
Author: ShineTheme
Author URI: https://travelerwp.com
License: GPLv2 or later
Text Domain: traveler-billplz
*/
class Traveler_Billplz_Payment
{
    public $pluginUrl = '';
    public $pluginPath = '';
    public $customFolder = 'traveler-billplz';

    public function __construct()
    {
        $this->pluginPath = trailingslashit(plugin_dir_path(__FILE__));
        $this->pluginUrl = trailingslashit(plugin_dir_url(__FILE__));

        //if($this->billz_get_currency() && $this->billz_get_currency() == 'MYR'){
            add_action('plugins_loaded', [$this, '_pluginSetup']);
            add_action('init', [$this, '_pluginLoader'], 20);
            add_action('wp_enqueue_scripts', [$this, '_pluginEnqueue']);
        //}
        
    }

    public function billz_get_currency(){
        $name_curency = false;
        $cookie_currency = isset( $_COOKIE['currency'] ) ? unserialize(stripslashes(gzuncompress(base64_decode($_COOKIE['currency'])))) : false;
        if (isset($cookie_currency['currency'])) {
            $name_curency = $cookie_currency['currency']['name'] ;
        }
        if(!empty($_GET['currency'])){
            $name_curency = sanitize_text_field($_GET['currency']);
        }
        return $name_curency;
    }

    public function _pluginSetup()
    {
        load_plugin_textdomain('traveler-billplz', false, basename(dirname(__FILE__)) . '/languages');
    }

    public function _pluginLoader()
    {
        if (class_exists('STTravelCode') && class_exists('STAbstactPaymentGateway')) {
            require_once($this->pluginPath . 'inc/BillplzAPI.php');
            require_once($this->pluginPath . 'inc/BillplzConnect.php');
            require_once($this->pluginPath . 'inc/BillplzBankName.php');
            require_once($this->pluginPath . 'inc/billplz.php');
        }
    }

    public function _pluginEnqueue()
    {
        
    }

    public function loadTemplate($name, $data = null)
    {
        if (is_array($data))
            extract($data);

        $template = $this->pluginPath . 'views/' . $name . '.php';

        if (is_file($template)) {
            $templateCustom = locate_template($this->customFolder . '/views/' . $name . '.php');
            if (is_file($templateCustom)) {
                $template = $templateCustom;
            }
            ob_start();

            require($template);

            $html = @ob_get_clean();

            return $html;
        }


    }

    public static function get_inst()
    {
        static $instance;

        if (is_null($instance)) {
            $instance = new self();
        }

        return $instance;
    }
}

Traveler_Billplz_Payment::get_inst();